<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:misp="http://www.infosharp.org/misp">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="no" omit-xml-declaration="yes"/>
	<xsl:variable name="br" select="'&#x0d;&#x0a;'"/>
	<xsl:template match="/">
		<xsl:apply-templates select="SOAP-ENV:Envelope/SOAP-ENV:Body"/>
	</xsl:template>
	<xsl:template match="SOAP-ENV:Envelope/SOAP-ENV:Body">
		<xsl:apply-templates select="misp:GetCapabilitiesResponse/misp:WFS_Capabilities/misp:FeatureTypeList"/>
	</xsl:template>
	<xsl:template match="misp:GetCapabilitiesResponse/misp:WFS_Capabilities/misp:FeatureTypeList">
		<xsl:for-each select="misp:FeatureType/misp:Name">
			<xsl:variable name="cnt">
				<xsl:number level="any" format="1" count="misp:Name"/>
			</xsl:variable>
			<xsl:variable name="featureName">
   		      <xsl:value-of select="normalize-space(.)"/>
			</xsl:variable>
			<xsl:variable name="featurePrefix">
				<xsl:value-of select="substring-before($featureName,':')"/>
			</xsl:variable>
			<xsl:if test="string-length($featurePrefix)>0">
				<xsl:variable name="featureLocal">
					<xsl:value-of select="substring-after($featureName,':')"/>
				</xsl:variable>
				<xsl:variable name="featureUri">
					<xsl:value-of select="string(namespace::*[name()=$featurePrefix])"/>
				</xsl:variable>
<xsl:value-of select="$cnt"/>:{<xsl:value-of select="$featureUri"/>}<xsl:value-of select="$featureLocal"/><xsl:value-of select="$br"/>
			</xsl:if>
			<xsl:if test="string-length($featurePrefix)=0">
<xsl:value-of select="$cnt"/>:<xsl:value-of select="$featureName"/><xsl:value-of select="$br"/>
			</xsl:if>
</xsl:for-each>
</xsl:template>
</xsl:stylesheet>
