package xmlCsv;

import java.io.PrintWriter;
import java.io.IOException;


// XXX: CsvReader and CsvColumnWriter should be symmetric

public class CsvColumnWriter
{
	public	static	void	write( PrintWriter  writer , String  data )
							throws IOException
	{
		if ( checkHaveSpecialCharacter( data ) )
		{
			printQuotedData( writer , data );
		}
		else
		{
			writer.print( data );
		}
	}


	private	static	boolean	checkHaveSpecialCharacter( String  data )
	{
		for ( int  i = 0  ;  i < data.length()  ;  ++ i )
		{
			char  ch = data.charAt(i);

			if ( ch == '\r'
			  || ch == '\n'
			  || ch == ','
			  || ch == '"' )
			{
				return( true );
			}
		}

		return( false );
	}

	private	static	void	printQuotedData( PrintWriter  writer ,
						 String  data )
	{
		writer.print( '"' );

		for ( int  i = 0  ;  i < data.length()  ;  ++ i )
		{
			char  ch = data.charAt(i);

			if ( ch == '"' )
			{
				writer.print( "\"\"" );
			}
			else
			{
				writer.print( ch );
			}
		}

		writer.print( '"' );
	}
}
