package daruma.geometry;

import daruma.geometry.Geometry;
import daruma.geometry.Point;

import java.util.List;
import java.util.ArrayList;

public class Polygon extends Geometry
{
	private	List<Point>	points;

	public	Polygon()
	{
		this.points = new ArrayList<Point>();
	}

	public	void	add( Point  point )
	{
		this.points.add( point );
	}

	public	List<Point>	getPoints()
	{
		return( this.points );
	}

	public	Point	get( int  index )
	{
		return( this.points.get( index ) );
	}

	public	boolean	closed()
	{
		if ( this.getPoints().size() == 0 )
		{
			return( false );
		}

		return( this.points.get(0)
			.equals( this.points.get(this.points.size() - 1)) );
	}
}
