package daruma.sql;

// XXX: should be an abstract class ?
public class SQLDataType
{
	private	String	sqlDataTypeName;
	private	String	sqlRetrieveFunction;
	private	Class	javaClass;

	public	SQLDataType( String  sqlDataTypeName ,
			     String  sqlRetrieveFunction ,
			     Class  javaClass )
	{
		this.sqlDataTypeName     = sqlDataTypeName;
		this.sqlRetrieveFunction = sqlRetrieveFunction;
		this.javaClass           = javaClass;
	}

	public	SQLDataType( String  sqlDataTypeName ,
			     Class  javaClass )
	{
		this.sqlDataTypeName     = sqlDataTypeName;
		this.sqlRetrieveFunction = null;
		this.javaClass           = javaClass;
	}

	public	String	getSQLDataTypeString()
	{
		return( this.sqlDataTypeName );
	}

	public	String	getSQLRetrieveColumnString( String  columnName )
	{
		if ( this.sqlRetrieveFunction != null )
		{
			return( this.sqlRetrieveFunction
				+ "(`" + columnName + "`)" );
		}
		else
		{
			return( columnName );
		}
	}

	public	String	getSQLRetrieveColumnStringForRawSQLString
							( String  columnName )
	{
		if ( this.sqlRetrieveFunction != null )
		{
			return( this.sqlRetrieveFunction
				+ "(`" + columnName + "`)" );
		}
		else
		{
			return( "`" + columnName + "`" );
		}
	}


	public	boolean	isTimeFamilyType()
	{
		return( this.getSQLDataTypeString().equals( "datetime" )
			|| this.getSQLDataTypeString().equals( "timestamp" ) );
	}

	/*
	public	boolean	isNotNull()
	{
	}
	*/

	// XXX: boolean needQuotes() or escapeValue( String  value ) etc...

	public	Class  getJavaClass()
	{
		return( this.javaClass );
	}
}
