package daruma.strage_manager.type_definition;

import daruma.strage_manager.type_definition.TypeDefinition;
import daruma.strage_manager.type_definition.TypedInstance;
import daruma.strage_manager.type_definition.TypeException;
import daruma.strage_manager.StrageManager;
import daruma.strage_manager.StrageException;
import daruma.sql.SQLDataType;
import daruma.sql.TableColumn;
import daruma.sql.TableColumnDefinition;
import daruma.xml.UniversalName;
import daruma.xml.SimpleXPath;
import daruma.xml.util.ElementUtil;
import daruma.util.Pair;

import org.w3c.dom.Element;
import org.w3c.dom.Document;

import java.util.List;
import java.util.ArrayList;


public abstract class AbstractSingleTypeDefinition extends TypeDefinition
{
	public	AbstractSingleTypeDefinition()
	{
		super( false , false );
	}

	@Override
	public	abstract SQLDataType	getSingleSQLDataType();

	public	abstract String		parseValue( String  value )
							throws TypeException;

	public	Pair<TypedInstance, Integer>
				createInstance( Element  element ,
						ElementName  topLevelElement ,
						SimpleXPath  path ,
						StrageManager  strage ,
						int  elementIndex )
							  throws TypeException
	{
		System.err.println( this.getClass().getName()
				    + ": createInstance()" );

		String	value = null;

		try
		{
			value = this.parseValue
				( ElementUtil
				  .getChildNodesWholeText( element ) );
		}
		catch( TypeException  e )
		{
			throw new TypeException( e.getMessage() , e );
		}


		String	columnName;
		if ( path == null )
		{
			columnName = ElementColumnNameFactory
						    .getTopLevelColumnName();
		}
		else
		{
			SimpleXPath	newPath = new SimpleXPath( path );

			newPath.add( new UniversalName
				     ( element.getNamespaceURI() ,
				       element.getLocalName() ) );

			try
			{
				columnName
				    = strage.getShortXPathString( newPath );
			}
			catch( StrageException  e )
			{
				throw new TypeException( e );
			}
		}

		TableColumn	column;
		column = new TableColumn( new TableColumnDefinition
					  ( columnName ,
					    this.getSingleSQLDataType() ) ,
					  value );

		List<TableColumn>  columnList = new ArrayList<TableColumn>();
		columnList.add( column );

		return( new Pair<TypedInstance, Integer>
			( new TypedInstance( columnList , this ) , -1 ) );
	}

	@Override
	public	 int	convertToXMLElement( Element  element ,
					     Document  doc ,
					     StrageManager  strage ,
					     List<TableColumn>  columns ,
					     int  index ,
					     long  id ) throws TypeException
	{
		return( 0 );
	}
}
