package daruma.strage_manager.type_definition;

import daruma.strage_manager.type_definition.TypedInstance;
import daruma.strage_manager.type_definition.TypeException;
import daruma.strage_manager.StrageManager;

import daruma.sql.DatabaseConnection;
import daruma.sql.DatabaseConnectionException;

import java.sql.SQLException;


public class TypedInstanceSet
{
	private	TypeDefinition			type;
	private	DatabaseConnection.QueryResult	queryResult;
	private	java.sql.ResultSet		r;
	private	StrageManager			strage;

	public	TypedInstanceSet( TypeDefinition  type ,
				  DatabaseConnection.QueryResult  queryResult ,
				  StrageManager  strage )
						    throws TypeException
	{
		this.type        = type;
		this.queryResult = queryResult;
		this.r           = null;
		this.strage      = strage;

		try
		{
			this.r = queryResult.getResultSet();
		}
		catch( DatabaseConnectionException  e )
		{
			throw new TypeException( e );
		}
	}


	public	TypedInstance	getNextTypedInstance() throws TypeException
	{
		boolean	hasNext = false;

		try
		{
			hasNext = this.r.next();
		}
		catch( SQLException e )
		{
			throw new TypeException( e );
		}

		if ( hasNext )
		{
			return( new TypedInstance( this.type ,
						   this.queryResult ,
						   this.strage ) );
		}
		else
		{
			return( null );
		}
	}


	public	void	close() throws TypeException
	{
		try
		{
			if ( this.queryResult != null )
			{
				this.queryResult.close();
			}
		}
		catch( DatabaseConnectionException  e )
		{
			throw new TypeException( e );
		}
	}
}
