package daruma.strage_manager.type_definition.types;

import daruma.strage_manager.type_definition.AbstractCompositorTypeDefinition;

import daruma.strage_manager.type_definition.TypeDefinition;
import daruma.strage_manager.type_definition.TypeName;
import daruma.strage_manager.type_definition.ElementName;
import daruma.strage_manager.type_definition.TypedInstance;
import daruma.strage_manager.type_definition.TypeException;
import daruma.strage_manager.StrageManager;
import daruma.strage_manager.StrageException;
import daruma.sql.TableColumn;
import daruma.xml.UniversalName;
import daruma.xml.SimpleXPath;
import daruma.util.Pair;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Element;

import java.util.List;
import java.util.ArrayList;


public class AllTypeDefinition extends AbstractCompositorTypeDefinition
{
	public	AllTypeDefinition()
	{
		super();
	}

	@Override
	public	Pair<TypedInstance, Integer>
				createInstance( Element  element ,
						ElementName  topLevelElement ,
						SimpleXPath  path ,
						StrageManager  strage ,
						int  elementIndex )
							  throws TypeException
	{
		System.err.println();
		System.err.println();
		System.err.println( this.getClass().getName()
				    + ": createInstance()" );
		System.err.println( "elementIndex = " + elementIndex );
		System.err.println( "--" );
		super.debugPrint();
		System.err.println( "--" );


		ElementName	parentElementName = new ElementName( element );

		int		nThChildNode = elementIndex;
		NodeList	childNodes = element.getChildNodes();

		List<Element>	tagList = new ArrayList<Element>();

		for(;;)
		{
			if ( nThChildNode >= childNodes.getLength() )
			{
				throw new TypeException
					  ( "too few child elements of "
					    + parentElementName.toString() );
			}

			Node	n = childNodes.item( nThChildNode );

			if ( n instanceof Element )
			{
				// XXX: check tag equals <annotation>

				tagList.add( (Element)n );

				if ( tagList.size()
				     == this.getEntries().size() )
				{
					nThChildNode ++;
					break;
				}
			}

			nThChildNode ++;
		}


		for( Entry  entry  :  this.getEntries() )
		{
			ElementName	expectedElementName
					= entry.getAtomEntry().getSecond();

			System.err.println( "[" + expectedElementName + "]" );
		}

		for( Element  t  :  tagList )
		{
			ElementName	tag = new ElementName( t );

			System.err.println( "[[" + tag + "]]" );
		}


		List<Element>	sortedTagList = new ArrayList<Element>();

		// XXX: should use Map?
		for( Entry  entry  :  this.getEntries() )
		{
			for( Element  t  :  tagList )
			{
				if ( entry.getAtomEntry().getSecond()
				     .equals( new ElementName( t ) ) )
				{
					sortedTagList.add( t );

					break;
				}
			}
		}

		if ( sortedTagList.size() != this.getEntries().size() )
		{
			throw new TypeException
				  ( "invalid child elements of "
				    + parentElementName.toString() );
		}


		List<TableColumn>  columnList = new ArrayList<TableColumn>();

		for ( int  i = 0  ;  i < super.getEntries().size()  ;  ++ i )
		{
			Entry	entry = super.getEntries().get(i);

			assert ! entry.isCompositeEntry();

			ElementName	expectedElementName
					= entry.getAtomEntry().getSecond();

			System.err.println( "expected element = ["
					    + expectedElementName + "]" );

			TypeName	typeName
					= entry.getAtomEntry().getFirst();

			System.err.println( "typeName = [" + typeName + "]" );

			TypeDefinition	type;

			try
			{
				type = strage.getTypeDefinition( typeName );
			}
			catch( StrageException  se )
			{
				throw new TypeException( se );
			}

			System.err.println( "type.class = "
					    + type.getClass().getName() );


			SimpleXPath	p = new SimpleXPath( path );

			if ( path != null )
			{
				p.add( new UniversalName( element ) );
			}


			TypedInstance	obj = type.createInstance
						   ( sortedTagList.get(i) ,
						     topLevelElement ,
						     p ,
						     strage ,
						     0 ).getFirst();

			columnList.addAll( obj.getColumns() );
		}

		System.err.println();
		System.err.println();


		return( new Pair<TypedInstance, Integer>
			( new TypedInstance( columnList , this ) ,
			  nThChildNode ) );
	}
}
