package daruma.strage_manager.type_definition.types;

import daruma.strage_manager.type_definition.TypeDefinition;
import daruma.strage_manager.type_definition.TypedInstance;
import daruma.strage_manager.type_definition.TypeException;
import daruma.strage_manager.type_definition.ElementName;
import daruma.strage_manager.StrageManager;

import daruma.sql.SQLDataType;
import daruma.sql.TableColumnDefinition;
import daruma.sql.TableColumn;

import daruma.xml.SimpleXPath;
import org.w3c.dom.Element;
import org.w3c.dom.Document;

import daruma.util.Pair;
import java.util.List;


public class SimpleTypeDefinition extends TypeDefinition
{
	private	TypeDefinition	base;

	public	SimpleTypeDefinition( TypeDefinition  base )
	{
		super( base.isXMLComplexType() ,
		       base.isSQLMultiColumn() );

		this.base = base;
	}

	@Override
	public SQLDataType	getSingleSQLDataType()
	{
		return( this.base.getSingleSQLDataType() );
	}


	@Override
	public	List<TableColumnDefinition>	getCompositeSQLDataType
						  ( StrageManager  strage ,
						    SimpleXPath  path )
							throws TypeException
	{
		return( this.base.getCompositeSQLDataType( strage , path ) );
	}


	@Override
	public	Pair<TypedInstance, Integer>
				createInstance( Element  element ,
						ElementName  topLevelElement ,
						SimpleXPath  path ,
						StrageManager  strage ,
						int  elementIndex )
							throws TypeException
	{
		return( this.base.createInstance( element ,
						  topLevelElement ,
						  path ,
						  strage ,
						  elementIndex ) );
	}


	@Override
	public	int	convertToXMLElement( Element  element ,
					     Document  doc ,
					     StrageManager  strage ,
					     List<TableColumn>  columns ,
					     int  index ,
					     long  id )
							throws TypeException
	{
		return( this.base.convertToXMLElement( element ,
						       doc ,
						       strage ,
						       columns ,
						       index ,
						       id ) );
	}
}
