package daruma.util;

import java.io.*;

public class CloseIgnoreInputStream extends InputStream
{
	private	InputStream	in;

	public	CloseIgnoreInputStream( InputStream  in )
	{
		this.in  = in;
	}

	public	int	read() throws IOException
	{
		if ( in == null )
		{
			return( -1 );
		}

		return( in.read() );
	}

	public	int	read( byte[]  b ,  int  off ,  int  len )
							throws IOException
	{
		if ( in == null )
		{
			return( -1 );
		}

		return( in.read( b , off , len ) );
	}

	public	long	skip( long  n ) throws IOException
	{
		if ( in != null )
		{
			return( in.skip( n ) );
		}
		else
		{
			return( 0 );
		}
	}

	public	int	available() throws IOException
	{
		if ( in != null )
		{
			return( in.available() );
		}
		else
		{
			return( 0 );
		}
	}

	public	void	mark( int  readlimit )
	{
		if ( in != null )
		{
			in.mark( readlimit );
		}
	}

	public	void	reset() throws IOException
	{
		if ( in != null )
		{
			in.reset();
		}
	}

	public	boolean	markSupported()
	{
		if ( in != null )
		{
			return( in.markSupported() );
		}
		else
		{
			return( false );
		}
	}

	public	void	close() throws IOException
	{
	}

	public	void	realClose() throws IOException
	{
		if ( in != null )
		{
			in.close();
		}
	}
}
