package daruma.util;

import java.io.IOException;
import java.io.OutputStream;

public class TeeOutputStream extends OutputStream
{
	private	OutputStream	out1;
	private	OutputStream	out2;
	private	boolean		closeOutput2 = true;

	public	TeeOutputStream( OutputStream  out1 ,  OutputStream  out2 )
	{
		this.out1 = out1;
		this.out2 = out2;
	}

	public	TeeOutputStream( OutputStream  out1 ,  OutputStream  out2 ,
				 boolean  closeOutput2 )
	{
		this.out1 = out1;
		this.out2 = out2;
		this.closeOutput2 = closeOutput2;
	}

	public	void	write( int  b ) throws IOException
	{
		if ( out1 != null )
		{
			out1.write( b );
		}

		if ( out2 != null )
		{
			out2.write( b );
		}
	}

	public	void	write( byte[]  b ,  int  off ,  int  len )
		throws IOException
	{
		if ( out1 != null )
		{
			out1.write( b , off , len );
		}

		if ( out2 != null )
		{
			out2.write( b , off , len );
		}
	}

	public	void	flush() throws IOException
	{
		if ( out1 != null )
		{
			out1.flush();
		}

		if ( out2 != null )
		{
			out2.flush();
		}
	}

	public	void	close() throws IOException
	{
		if ( out1 != null )
		{
			out1.close();
		}

		if ( out2 != null && this.closeOutput2 )
		{
			out2.close();
		}
	}
}
