package daruma.wfs;

import daruma.wfs.insert.InsertAnElementHandler;

import daruma.xml.handler.XSAXDefaultHandler;
import daruma.xml.XMLTag;
import daruma.xml.URI;

import daruma.strage_manager.StrageManager;

import org.xml.sax.XMLReader;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import java.io.OutputStream;


public class TransactionInsertHandler extends XSAXDefaultHandler
{
	private	StrageManager		strage;
	private	TransactionHandler	errorReceiver;

	public	TransactionInsertHandler( OutputStream  out ,
					  XMLReader  parser ,
					  boolean  isTopLevelHandler ,
					  StrageManager  strage ,
					  TransactionHandler  errorReceiver )
	{
		super( out , parser , isTopLevelHandler );

		this.strage        = strage;
		this.errorReceiver = errorReceiver;
	}

	public	void	xStartElement( String uri ,
				       String localName ,
				       String qName ,
				       Attributes  attrs ) throws SAXException
	{
		assert super.getCurrentLevel() == 1
			|| super.getCurrentLevel() == 2;

		XMLTag	t = new XMLTag( uri , localName );

		if ( super.getCurrentLevel() == 1 )
		{
			if ( ! t.equals( new XMLTag( URI.MISP , "Insert" ) ) )
			{
				this.throwError( new SAXParseException
						 ( "unknown tag <"
						   + t.getLocalName()
						   + ">." ,
						   super.getLocator() ) );
			}

			return;
		}


		super.setContentHandlerDelegator
			( new InsertAnElementHandler
			  ( super.getOutputStream() ,
			    super.getParser() ,
			    false ,
			    this.strage ,
			    this.errorReceiver ) ,
			  uri , localName , qName , attrs );
	}


	private	void	throwError( SAXParseException  e ) throws SAXException
	{
		this.errorReceiver.notifyError( e );

		throw e;
	}
}
