package daruma.wfs.filter.predicates;

import daruma.wfs.filter.PredicateDescription;

import daruma.xml.util.XMLParseErrorException;
import org.w3c.dom.Element;

import daruma.strage_manager.StrageManager;
import daruma.strage_manager.type_definition.TypeDefinition;


public class ImmidiateValueBooleanDescription extends PredicateDescription
{
	public	static	boolean	isAcceptablePredicate( String  localName )
	{
		return( localName.equals( "True" )
		     || localName.equals( "False" ) );
	}

	private	String	sqlExpression;

	public	ImmidiateValueBooleanDescription
				( Element  element ,
				  TypeDefinition  type ,
				  StrageManager  strage )
					    throws XMLParseErrorException
	{
		super( strage , type );

		if ( element.getLocalName().equals( "True" ) )
		{
			this.sqlExpression = "TRUE";
		}
		else if ( element.getLocalName().equals( "False" ) )
		{
			this.sqlExpression = "FALSE";
		}
		else
		{
			throw new XMLParseErrorException
			  ( "cannot handle filter \""
			    + element.getLocalName() + "\"" );
		}
	}

	public	String	getSQLExpression()
	{
		return( this.sqlExpression );
	}
}
